# 홍쓰넷 CI/CD 서비스시연

홍쓰넷에서 제공하는 CI/CD 서비스는 다음 내역을 미리 참조하셔야 합니다.

- `git / ssh 만 지원` ( 향후 tomcat war 배포에 대한 기능도 추가할 예정 )
- git / jenkins 시스템모두 각각 네트워크 속도(Bandwidth)가 제한 : `30Mbps/second`
  - 단, Jenkins와 호스팅서버간의 Private Network는 `1Gbps`


# 홍쓰넷 CI/CD 구성도

![hongsnet_ci_cd](/uploads/54ca0c85cd5d9a0c9ab59df178146478/hongsnet_ci_cd.png)


# STEP 1 : 홍쓰넷 Git 저장소를 Clone

먼저 https://git.freehongs.net 에 로그인 한 후 아래와 같이 Clone을 클릭 합니다.

![gitlab1](/uploads/253b1616094dd89f8e7959684a0ff4fb/gitlab1.png)


그 후 PC에서 각종 Git 툴을 사용하여, 다음과 같이 Clone 합니다.

```bash
$ git clone https://GitLAB_ID_Token@git.freehongs.net/GitLAB_ID_Token/GitLAB_Project_Token.git
Password for 'https://GitLAB_ID_Token@git.freehongs.net':
Cloning into 'GitLAB_Project_Token'...
remote: Enumerating objects: 27, done.
remote: Counting objects: 100% (27/27), done.
remote: Compressing objects: 100% (15/15), done.
remote: Total 27 (delta 8), reused 24 (delta 5), pack-reused 0
Unpacking objects: 100% (27/27), done.
```

그리고 위의 복잡한 Token 정보로 인해, 매번 로그인을 해야하기 때문에 Credential.helper 설정을 다음과 같이 진행 합니다. 이 로그인 정보는 `반영구적으로 보관` 됩니다.

```bash
$ git config --global credential.helper store
```

> 중요 : 홍쓰넷 GitLAB은 https만 지원하기 때문에 반드시 https://GitLAB_ID_Token@git.freehongs.net/GitLAB_ID_Token/GitLAB_Project_Token.git 형식으로 Clone 해야 합니다. 만약 이 형식이 아닐 경우 Credential.helper 설정이 동작하지 않습니다.


# STEP 2 : GitLAB에 Jenkins WebHook을 등록 [ 관리자가 사전에 세팅수행 ]


# STEP 3 : Jenkins 프로젝트의 Build Script를 작성

> https://jenkins.freehongs.net

홍쓰넷 로그인정보를 입력하여 로그인 합니다.

![jenkins](/uploads/163900156a5c270e32e55b3f10b2771b/jenkins.png)

> Jenkins ID & Project Token 정보는 홍쓰넷 MYPAGE에 있습니다.


로그인이 완료되었으면, 미리 생성된 프로젝트의 구성으로 이동 합니다.

![jenkins1](/uploads/7d000e98db9876651ef717a76bbe45b2/jenkins1.png)


Build 후 조치는 회원이 직접 작성해야하는 것으로써 홍쓰넷관리자는 다음과 같은 구성을 통해 배포하고 있습니다.

![jenkins2](/uploads/1ea18be09c88fc3c4a04a3a21c864734/jenkins2.png)

> SSH 서버의 홈디렉토리는 `/homeX/계정명` 입니다. 자세한 내역은 홍쓰넷 MYPAGE를 참조하세요.

- `Name` : 관리자가 등록한 회원의 SSH 접속서버명(홍쓰넷 MYPAGE에 SSH Token을 참조)
- `Source files` : 배포할 소스파일을 입력합니다. 위 처럼, 특정 파일을 지정할 수 있고, `**/*`와 같이 전체파일을 지정할 수도 있습니다.
- `Remove prefix` : 경로 중에 제거할 필요가 있는 경로를 지정
- `Exec command` : 빌드 후 호스팅서버에 실행할 명령어를 지정, 아래는 관리자가 사용하는 예시 입니다.


아래의 명령은 빌드를 수행한 후 `톰캣을 중지 후 2초대기하고, 다시 시작하는 명령`을 지정한 예시(위 그림의 빨강네모박스) 입니다.


```bash
export JRE_HOME=/homeX/계정명/jdk
export JAVA_HOME=/homeX/계정명/jdk
export ANT_HOME=/homeX/계정명/ant
export CATALINA_HOME=/homeX/계정명/tomcat
export CATALINA_BASE=/homeX/계정명/tomcat
export CATALINA_PID=/homeX/계정명/tomcat/catalina.pid
export CLASSPATH=$JAVA_HOME/lib/tools.jar:$JAVA_HOME/lib/*:.
export PATH=$JAVA_HOME/bin:$CATALINA_HOME/bin:$ANT_HOME/bin:$PATH:$HOME/bin
LD_LIBRARY_PATH=/homeX/계정명/jdk/bin/../lib/jli
LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/homeX/계정명/tomcat/lib
export LD_LIBRARY_PATH

tomcat/bin/shutdown.sh
sleep 2
tomcat/bin/startup.sh
```

<!--
- `-avz` : 아카이브 모드, 심볼릭 링크, 속성, 퍼미션, 소유권 등 보존
- `--progress` : 진행과정을 세부적으로 출력
- `--delete` : 로컬(Jenkins)과 원격(호스팅서버)와의 차이가 발생한 파일을 제거
   - 이 옵션을 통해 로컬과 원격지의 소스를 동기화활 수 있습니다.
- ./ : 현재 로컬의 경로를 의미 합니다.
- 172.16~~ : 홍쓰넷 MYPAGE에 명시되어있는 `CI/CD 사설IP` 필드의 값을 입력해야 합니다.
- ~~Fbcurm : 각 사용자별로 생성된 SSH Token 값으로서 홍쓰넷 MYPAGE에 명시되어 있는 `SSH Token` 필드의 값을 입력해야 합니다.
- `/ROOT/` : 경로를 의미 합니다. 다음의 호스팅별로 차이가 있으므로, 주의해야 합니다.
    - JSP 호스팅 : ~/tomcat/webapps [ Default 경로 ]
      - e.g, Rsync_Token/ROOT/ => ~/tomcat/webapps/ROOT/ 를 의미
    - PHP 호스팅 : ~/public_html [ Default ] 
      - e.g, Rsync_Token/ => ~/public_html/ 를 의미
-->


# STEP 3-1 : 실질적인 소스배포를 진행

- GitLab 저장소 정보

```bash
$ git remote -v
origin  https://GitLAB_ID_Token@git.freehongs.net/GitLAB_ID_Token/GitLAB_Project_Token.git (fetch)
origin  https://GitLAB_ID_Token@git.freehongs.net/GitLAB_ID_Token/GitLAB_Project_Token.git (push)
```

- 호스팅 서버의 파일리스트

```bash
[SSH:~/tomcat/webapps/ROOT]$ ls
[SSH:~/tomcat/webapps/ROOT]$
```


다음과 같이 index.html 파일을 만들어 배포되는 것을 확인해 보겠습니다.

```bash
$ cat index.html
<html>
        <head>
                <title> www.hongsnet.net </title>
        </head>
        <body>
                Hello www.hongsnet.net!
        </body>
</html>
```

다음과 같이 추가하고 commit 합니다.

```bash
$ git add index.html
$ git commit -m "www.hongsnet.net, test index.html"
[master a7c9bd9] www.hongsnet.net, test index.html
 1 file changed, 8 insertions(+)
 create mode 100644 index.html
```

마지막으로 push 합니다.

```bash
$ git push -u origin master
Counting objects: 3, done.
Delta compression using up to 8 threads.
Compressing objects: 100% (2/2), done.
Writing objects: 100% (3/3), 334 bytes | 111.00 KiB/s, done.
Total 3 (delta 0), reused 0 (delta 0)
To https://git.freehongs.net/GitLAB_ID_Token/GitLAB_Project_Token.git
   4347838..a7c9bd9  master -> master
Branch 'master' set up to track remote branch 'master' from 'origin'.
```

# STEP 3-2 : `GitLab/Jenkins/호스팅서버`의 배포내역을 확인

- **GitLAB**

![jenkins3](/uploads/cd657b9600c90d318b39e80ec27ca93b/jenkins3.png)


- **Jenkins**

![jenkins4](/uploads/847764870353be86235f863651a871b0/jenkins4.png)

클릭한 **"Console Output"** 을 보면, 다음과 같이 정상적으로 서버에 업로드된 것이 확인 됩니다.

```plaintext
Started by GitLab push by XXXX
Running as SYSTEM
Building in workspace /var/lib/jenkins/workspace/XXXX
[WS-CLEANUP] Deleting project workspace...
[WS-CLEANUP] Deferred wipeout is used...
[WS-CLEANUP] Done
The recommended git tool is: NONE
using credential XXXXXX
Cloning the remote Git repository
Cloning repository https://git.freehongs.net/XXXX/XXXXX.git
 > git init /var/lib/jenkins/workspace/XXXXX # timeout=10
Fetching upstream changes from https://git.freehongs.net/XXXX/XXXXX.git
 > git --version # timeout=10
 > git --version # 'git version 1.8.3.1'
using GIT_ASKPASS to set credentials XXXXX GIT LAB
 > git fetch --tags --progress https://git.freehongs.net/XXXXX/XXXXX.git +refs/heads/*:refs/remotes/origin/* # timeout=10
 > git config remote.origin.url https://git.freehongs.net/XXXXXX/XXXXX.git # timeout=10
 > git config --add remote.origin.fetch +refs/heads/*:refs/remotes/origin/* # timeout=10
Avoid second fetch
skipping resolution of commit remotes/origin/master, since it originates from another repository
 > git rev-parse refs/remotes/origin/master^{commit} # timeout=10
Checking out Revision 58a6d (refs/remotes/origin/master)
 > git config core.sparsecheckout # timeout=10
 > git checkout -f 58a6d # timeout=10
Commit message: "index.html 업데이트"
 > git rev-list --no-walk 8ee # timeout=10
SSH: Connecting from host [jenkins.freehongs.net]
SSH: Connecting with configuration [XXXXXXX] ...
SSH: EXEC: completed after 3,602 ms
SSH: Disconnecting configuration [XXXXXX] ...
SSH: Transferred 1 file(s)
Finished: SUCCESS

```

> SSH: EXEC: completed after 3,602 ms 톰캣 재시작명령들이 정상적으로 완료되었다는 메시지이며, 실제 서버에서도 정상적으로 동작 합니다.


- **호스팅 서버**

다음과 같이 정상적으로 배포된 것을 확인할 수 있습니다.

```bash
$ ls -al
total 16
drwxr-xr-x 3 1XXX XXXX 4096 Jan  4 18:55 .
drwxr-xr-x 3 1XXX XXXX 4096 Jan  4 03:21 ..
-rw-r--r-- 1 1XXX XXXX  111 Jan  4 18:55 index.html
```


# STEP 4 : 배포한 index.html 파일이 제대로 변경되었는지를 검증


