[![logo](https://www.hongsnet.net/images/logo.gif)](https://www.hongsnet.net)

# JSP 호스팅신청 절차

홍쓰넷 호스팅은 다음의 절차에 따라 신청 및 세팅이 진행 됩니다.

> 회원가입 -> OTP 인증 -> 호스팅신청 -> 관리자세팅 -> 완료


# JSP 호스팅 초기설정

- 호스팅세팅완료 후 확인

> MYPAGE 이동(로그인 필수) > 기본서비스정보 확인

![jsp_hosting1](/uploads/82032ff5743e9d1be1f719086965de80/jsp_hosting1.png)

- 호스팅계정정보 확인

> MYPAGE > 서버접속확인

![jsp_hosting2](/uploads/9e31db1c302a4148b63ddf05cc7b057a/jsp_hosting2.png)

1. 서버계정의 패스워드정보를 확인하려면, "계정비밀번호 보기" 버튼을 클릭 합니다.
2. SSH/SFTP 접속은 기본적으로 접근이 불가능하며, 접속을 원할경우 "서버접속IP 관리" 버튼을 통해 신청하셔야 합니다. 

- 세팅완료 후 사이트접속

다음과 같이 호스팅세팅이 완료되면, 세팅완료 페이지가 기본적으로 응답하게 됩니다.

![jsp_hosting3](/uploads/31feac92ea79073f7ace80108017de43/jsp_hosting3.png)

# JSP 호스팅서버설정 확인

- [ `STEP 1` ] : MYPAGE의 "서버접속IP 관리" 버튼을 클릭하면 세창에 출력 됩니다.

![jsp_hosting4](/uploads/3ea83f00cb907d63ddbbb27e67f7b58e/jsp_hosting4.png)

1. 위의 "시작일자" 와 "종료일자" 를 선택합니다. 참고적으로 종료일자는 신청일을 기준으로 최대 1일만 제공 됩니다.
2. "허용할 IP주소" 는 현재 PC의 IP가 자동으로 기입되며, 만약 IP가 다를 경우 별도로 입력하시면 됩니다.

- [ `STEP 2` ] : 서버에 SSH를 이용하여 접근 및 로그인 합니다.

![jsp_hosting5](/uploads/f818686637ec7822da37d339706836a2/jsp_hosting5.png)

> 위의 SSH 클라이언트 프로그램은 putty 입니다.

```bash
login as: dem <- 서버계정의 아이디 입력
dem@아이디.freehongs.net's password: <- 서버계정 패스워드 입력
############################################################################################# #######

Now you have shell access is restricted environment drastically command is actually available .
Create and delete directories, Jean-focused functionality for account only for backup and rec overy
Because the environment as a means to a Linux/UNIX learning is virtually impossible to use.

== you can use the command ==

cat chmod chown cp grep gunzip gzip ls mkdir mv mysql mysqldump rm tar vi zip unzip pwd sed

tail expr id uname sort date git

############################################################################################# #######
[SSH:~]$
```

- [ `STEP 3` ] : 위와 같이 로그인을 완료했으면, 디렉토리 및 파일들을 review 합니다.

```bash
[SSH:~]$ ls
ant  jdk  tomcat
```

> 이 경로가 회원계정의 최상위 경로 입니다.

```bash
[SSH:~]$ ls tomcat/
BUILDING.txt     LICENSE  README.md      RUNNING.txt  conf  logs  webapps
CONTRIBUTING.md  NOTICE   RELEASE-NOTES  bin          lib   temp  work
```

> Tomcat의 내역을 출력 합니다.

```bash
[SSH:~]$ ls tomcat/webapps/
ROOT  ROOT.war  hongsnet  jsp_readme.txt
```

> JSP 호스팅의 소스가 위치하는 WebRoot의 내역을 출력 합니다.


- 위의 경로들은 다음과 같이 MYPAGE에서도 확인할 수 있습니다.

![jsp_hosting6-1](/uploads/2f0737824396b8165596b189c1ec3bc0/jsp_hosting6-1.png)

1. `주의 1` : Tomcat Shutdown/AJP 포트를 임의로 변경하시면, 사이트동작에 문제가 발생되며 만약 다른 회원에게 피해가 발생될 경우 통보없이 호스팅이 차단 됩니다.
2. `주의 2` : WebRoot는 변경이 가능(즉시 처리불가)하지만, 최대한 그대로 사용하기 바랍니다. 


# JSP 호스팅 웹 소스적용 및 확인

웹 소스변경/배포는 대략적으로 다음과 같이 두 가지 방법이 사용될 것으로 보입니다.

- *.jsp 파일 등을 개별로 업로드하는 방법
- ROOT.war 파일을 이용한 전체배포 방법

## *.jsp 파일 등을 개별로 업로드하는 방법

다음과 같이 홍쓰넷에서 기본적으로 배포하는 세팅완료 페이지(index.html)를 변경하여 배포하는 방법은 다음과 같습니다.

사용하시는 에디터 프로그램 또는 SSH 클라이언트 프로그램을 통해 다음과 같이 소스를 변경해 보겠습니다.

```plaintext
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>:: HONGSNET FREEHOSTING ::</title>
<link href="https://www.hongsnet.net/css2/style_utf8.css" rel="stylesheet" type="text/css">
</head>
<body>
...중략
  <tr><td align="center"><h2>여기를 수정했습니다!</h3></td></tr> <= 이 줄을 추가
  <tr>
    <td class="copyright" align="center">COPYRIGHT (C) 2010-2020 HONGSNET ALL RIGHT RESERVED.</td>
  </tr>
</table>
</body>
</html>
```

![jsp_hosting7](/uploads/98b402e71aef52662c123b999a55afe9/jsp_hosting7.png)


> 홍쓰넷 JSP 호스팅은 기본적으로 웹 서버와 연동되기 때문에 html/image/css/js 등과 같이 Tomcat이 실행되지않아도 기본적인 html 웹 페이지의 동작은 가능 합니다.

## ROOT.war 파일을 이용한 전체배포 방법

세팅이 완료되면, 홍쓰넷에서 기본적으로 ROOT.war 파일이 배포 됩니다. 이 소스는 간단한 JSP 테스트 소스이며, 이용에 참고하시라는 목적으로 배포되기 때문에 문의는 사양 합니다.

```bash
[SSH:~]$ ls tomcat/webapps/
ROOT  ROOT.war <- 이 파일 hongsnet  jsp_readme.txt
```
> 중요 : ROOT.war 파일로 배포하려면, 먼저 현재 존재하는 ROOT 디레토리를 제거(rm -rf ROOT)하거나, 이름을 변경(mv ROOT ROOT_bak)해야 합니다.

```bash
[SSH:~/tomcat/webapps]$ ls
ROOT.war  ROOT_bak <- ROOT_bak으로 변경처리한 결과 hongsnet  jsp_readme.txt
```

- [ `STEP 1` ] : Tomcat을 실행해야 합니다.

먼저 tomcat/bin 디렉토리로 이동 합니다.

```bash
[SSH:~/tomcat/bin]$ pwd
/home2/dem/tomcat/bin
```

그런 후 startup.sh 스크립트를 실행하여, 톰캣을 기동 합니다.

```bash
[SSH:~/tomcat/bin]$ ./startup.sh
Using CATALINA_BASE:   /home2/dem/tomcat
Using CATALINA_HOME:   /home2/dem/tomcat
Using CATALINA_TMPDIR: /home2/dem/tomcat/temp
Using JRE_HOME:        /home2/dem/jdk
Using CLASSPATH:       /home2/dem/tomcat/bin/bootstrap.jar:/home2/dem/tomcat/bin/tomcat-juli.jar
Using CATALINA_PID:    /home2/dem/tomcat/catalina.pid
Tomcat started.
```

- [ `STEP 2` ] : ROOT.war 파일의 내역들이 다음과 같이 Unpack 된 것을 볼 수 있습니다.

```bash
[SSH:~/tomcat/webapps]$ ls ROOT/
403.jsp  500.jsp         META-INF  css         jdbctest.jsp  tomcat.gif
404.jsp  HelloWorld.jsp  WEB-INF   index.html  session.jsp
```

- [ `STEP 3` ] : 사이트를 확인 합니다.

![jsp_hosting8](/uploads/b159a5432da1562336a5c6d8d360fe48/jsp_hosting8.png)


여기까지 완료되었으면, JSP 호스팅을 사용할 준비가 된 것입니다.

